/* pam_password.c - PAM Password Management */

#include "pam_appl.h"
#include "pam_private.h"

int pam_chauthtok(pam_handle_t *pamh, int flags)
{
    int retval;

    IF_NO_PAMH("pam_chauthtok",pamh,PAM_SYSTEM_ERR);

    if ((retval = _pam_dispatch(pamh, flags | PAM_PRELIM_CHECK,
				PAM_CHAUTHTOK)) != PAM_TRY_AGAIN) {
	_pam_dispatch(pamh, flags, PAM_CHAUTHTOK);
    }

    /* must reset these authentication tokens */

    DROP(pam->authtok);
    DROP(pam->oldauthtok);

    return retval;
}
